<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>問題6.8 - 他の1次元写像 &mdash; 計算機実習2014</title>
    
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="author" title="このドキュメントについて" href="../about.html" />
    <link rel="top" title="計算機実習2014" href="../index.html" />
    <link rel="next" title="問題6.9 - ロジスティック写像のリアプノフ指数" href="../6-9_lyapunov/6-9.html" />
    <link rel="prev" title="問題6.6 - ファイゲンバウム定数の評価" href="../6-6_feigenbaum/6-6.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="../6-9_lyapunov/6-9.html" title="問題6.9 - ロジスティック写像のリアプノフ指数"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="../6-6_feigenbaum/6-6.html" title="問題6.6 - ファイゲンバウム定数の評価"
             accesskey="P">前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="label">
<span id="id1"></span><h1><a class="toc-backref" href="#id7">問題6.8 - 他の1次元写像</a><a class="headerlink" href="#label" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="contents topic" id="contents">
<p class="topic-title first">Contents</p>
<ul class="simple">
<li><a class="reference internal" href="#label" id="id7">問題6.8 - 他の1次元写像</a><ul>
<li><a class="reference internal" href="#id2" id="id8">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3" id="id9">作成したプログラム</a></li>
<li><a class="reference internal" href="#id4" id="id10">実習課題</a></li>
<li><a class="reference internal" href="#id5" id="id11">まとめ</a></li>
<li><a class="reference internal" href="#id6" id="id12">参考文献</a></li>
</ul>
</li>
</ul>
</div>
<div class="section" id="id2">
<h2><a class="toc-backref" href="#id8">シミュレーションの目的</a><a class="headerlink" href="#id2" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このシミュレーションの目的は、1次元写像</p>
<div class="math" id="equation-e1">
<p><span class="eqno">(1)</span><img src="../_images/math/4bb0468d990d6c7a3ad8da12a839fbad79ef25e8.png" alt="f(x)=xe^{r(1-x)}"/></p>
</div><div class="math" id="equation-e2">
<p><span class="eqno">(2)</span><img src="../_images/math/4295438e312efd607a690a57bfb6c2b1a4b8ba87.png" alt="f(x)=r\sin{\pi x}"/></p>
</div><p>の定性的な性質を調べることである。写像<a href="#equation-e1">(1)</a>は、伝染病の影響で個体数に上限のある生態系モデルの研究のために、生態学者たちに用いられた。これは、<a class="reference internal" href="../6-1_iterate_map/6-1.html#label"><em>問題6.1</em></a>で考えた写像</p>
<div class="math" id="equation-e3">
<p><span class="eqno">(3)</span><img src="../_images/math/8f461f191602641ecea10d32f4159c7f85066112.png" alt="f(x)=4rx(1-x)"/></p>
</div><p>よりもさらに複雑であるが、初期の個体数にどんな正の値を用いても、その個体数が正になることが好都合な点である。<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>の最大値には制限はないが、<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>が十分に大きくなると、<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>は実質的に0になり、その生物は絶滅してしまう。<img class="math" src="../_images/math/bcc2e2f0a93859b53fd7ce898e8cd64723bd0ee2.png" alt="0 &lt; r \le 1"/>および<img class="math" src="../_images/math/a0f5a360adeee4088716ef40d27624d7425250ea.png" alt="0 \le x \le 1"/>とした正弦関数による写像<a href="#equation-e2">(2)</a>は、非線形である以外には特別なことはない。</p>
</div>
<div class="section" id="id3">
<h2><a class="toc-backref" href="#id9">作成したプログラム</a><a class="headerlink" href="#id3" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>本シミュレーションでは、<a class="reference internal" href="../6-1_iterate_map/6-1.html#label"><em>問題6.1</em></a>や<a class="reference internal" href="../6-2_bifurcate/6-2.html#label"><em>問題6.2</em></a>で行ったように、異なる初期値<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>に対して時系列の発展の様子はどうなるか、また、十分時間の経過した後の<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>の振る舞いは、<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>によってどのように変化するか、ということをシミュレーションする。したがって問題6.1と問題6.2のプログラムの時間発展方程式の部分を書き換えるだけでよく、これらをパッケージ化したものを利用して、実行プログラムの中では関数の定義とパラメータの代入のみを行うように改良した。以下に作成したプログラムを列挙する。</p>
<ul class="simple">
<li>パラメータの設定ダイアログ( <a class="reference download internal" href="../_downloads/SetParameter4.py"><tt class="xref download docutils literal"><span class="pre">SetParameter.py</span></tt></a> )</li>
</ul>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!usr/bin/env python </span>
<span class="c"># -*- coding: utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, Mqy 2014.</span>
<span class="c">#</span>

<span class="kn">from</span> <span class="nn">Tkinter</span> <span class="kn">import</span> <span class="o">*</span>

<span class="k">class</span> <span class="nc">SetParameter</span><span class="p">():</span>

    <span class="k">def</span> <span class="nf">show_setting_window</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">parameters</span><span class="p">,</span> <span class="n">commands</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Show a parameter setting window.</span>
<span class="sd">                </span>
<span class="sd">        parameters: A list of dictionaries {&#39;parameter name&#39;:default_value}</span>
<span class="sd">        commands: A dictionary {&#39;name of button&#39;: command}</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span> <span class="o">=</span> <span class="n">Tk</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;Control Widget&#39;</span><span class="p">)</span>
        
        <span class="n">frame1</span> <span class="o">=</span> <span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">frame1</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;top&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">entry</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">parameter</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">parameters</span><span class="p">):</span>
            <span class="n">label</span> <span class="o">=</span> <span class="n">Label</span><span class="p">(</span><span class="n">frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="n">parameter</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="s">&#39; = &#39;</span><span class="p">)</span>
            <span class="n">label</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">row</span><span class="o">=</span><span class="n">i</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">sticky</span><span class="o">=</span><span class="n">E</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Entry</span><span class="p">(</span><span class="n">frame1</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">10</span><span class="p">))</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">row</span><span class="o">=</span><span class="n">i</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">delete</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">END</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">parameter</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">1</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">focus_set</span><span class="p">()</span>
       
        <span class="n">frame2</span> <span class="o">=</span> <span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">frame2</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;bottom&#39;</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">name</span><span class="p">,</span> <span class="n">command</span> <span class="ow">in</span> <span class="n">commands</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="n">button</span> <span class="o">=</span> <span class="n">Button</span><span class="p">(</span><span class="n">frame2</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="n">name</span><span class="p">,</span> <span class="n">command</span><span class="o">=</span><span class="n">command</span><span class="p">)</span>
            <span class="n">button</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;left&#39;</span><span class="p">,</span> <span class="n">fill</span><span class="o">=</span><span class="s">&#39;x&#39;</span><span class="p">)</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">mainloop</span><span class="p">()</span>
       
    <span class="k">def</span> <span class="nf">quit</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">destroy</span><span class="p">()</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>与えられた関数とパラメータに関して時系列変化を描画するプログラム( <a class="reference download internal" href="../_downloads/myplot_6_8_iterate.py"><tt class="xref download docutils literal"><span class="pre">myplot_6_8_iterate.py</span></tt></a> )</li>
</ul>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python </span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>

<span class="kn">import</span> <span class="nn">array</span> <span class="kn">as</span> <span class="nn">array</span>
<span class="kn">import</span> <span class="nn">matplotlib.pylab</span> <span class="kn">as</span> <span class="nn">plt</span>

<span class="k">def</span> <span class="nf">plot</span><span class="p">(</span><span class="n">function</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">r</span><span class="p">,</span> <span class="n">nmax</span><span class="p">):</span>
    <span class="n">x</span><span class="o">=</span><span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;d&#39;</span><span class="p">)</span>
    <span class="n">x</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">x0</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">nmax</span><span class="p">):</span>
        <span class="n">x</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">function</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">r</span><span class="p">))</span>
    <span class="n">n</span><span class="o">=</span><span class="nb">range</span><span class="p">(</span><span class="n">nmax</span> <span class="o">+</span> <span class="mi">1</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">n</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span> <span class="s">r&#39;$x_{0}=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">x0</span><span class="p">)</span> <span class="o">+</span> <span class="s">&#39; : &#39;</span> 
                      <span class="o">+</span> <span class="s">&#39;$r=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">r</span><span class="p">)</span> <span class="o">+</span> <span class="s">&#39; : &#39;</span>
                      <span class="o">+</span> <span class="s">&#39;$n_{\mathrm{max}}=$&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">nmax</span><span class="p">)</span>
             <span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="n">nmax</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">(</span><span class="nb">min</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="mf">0.1</span><span class="p">)</span><span class="o">-</span><span class="mf">0.1</span><span class="p">,</span><span class="nb">max</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">+</span><span class="mf">0.1</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s">r&#39;$n$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s">r&#39;$x$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;map&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="s">&quot;best&quot;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>与えられた関数とパラメータに関してBifurcation Diagramを描画するプログラム( <a class="reference download internal" href="../_downloads/myplot_6_8_bifurcation.py"><tt class="xref download docutils literal"><span class="pre">myplot_6_8_bifurcation.py</span></tt></a> )</li>
</ul>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python </span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>

<span class="kn">import</span> <span class="nn">matplotlib.pylab</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">array</span> <span class="kn">as</span> <span class="nn">array</span>

<span class="k">def</span> <span class="nf">Plot</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">ntransient</span><span class="p">,</span> <span class="n">nplot</span><span class="p">,</span> <span class="n">r0</span><span class="p">,</span> <span class="n">rmax</span><span class="p">,</span> <span class="n">dr</span><span class="p">):</span>
    <span class="k">global</span> <span class="n">x</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">rmax</span><span class="o">-</span><span class="n">r0</span><span class="p">)</span> <span class="o">%</span> <span class="n">dr</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
        <span class="n">count</span><span class="o">=</span><span class="nb">int</span><span class="p">((</span><span class="n">rmax</span><span class="o">-</span><span class="n">r0</span><span class="p">)</span><span class="o">/</span><span class="n">dr</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">count</span><span class="o">=</span><span class="nb">int</span><span class="p">((</span><span class="n">rmax</span><span class="o">-</span><span class="n">r0</span><span class="p">)</span><span class="o">/</span><span class="n">dr</span><span class="p">)</span>
    <span class="n">count</span><span class="o">=</span><span class="nb">int</span><span class="p">((</span><span class="n">rmax</span><span class="o">-</span><span class="n">r0</span><span class="p">)</span><span class="o">/</span><span class="n">dr</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">count</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
        <span class="n">r</span><span class="o">=</span><span class="n">r0</span><span class="o">+</span><span class="n">dr</span><span class="o">*</span><span class="n">n</span>
        <span class="n">_Plot</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="n">r</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">ntransient</span><span class="p">,</span> <span class="n">nplot</span><span class="p">)</span>
    <span class="n">_Plot</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="n">rmax</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">ntransient</span><span class="p">,</span> <span class="n">nplot</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="n">r0</span><span class="p">,</span><span class="n">rmax</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">(</span><span class="nb">min</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">-</span><span class="mf">0.3</span><span class="p">,</span><span class="nb">max</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">+</span><span class="mf">0.3</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s">r&#39;$r$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s">r&#39;$x$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;Bifurcation Diagram&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

<span class="k">def</span> <span class="nf">_Plot</span><span class="p">(</span><span class="n">function</span><span class="p">,</span> <span class="n">r</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">ntransient</span><span class="p">,</span> <span class="n">nplot</span><span class="p">):</span>
    <span class="k">global</span> <span class="n">x</span>
    <span class="n">n</span><span class="o">=</span><span class="n">ntransient</span><span class="o">+</span><span class="n">nplot</span><span class="o">*</span><span class="mi">2</span>
    <span class="n">x</span><span class="o">=</span><span class="n">array</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="s">&#39;f&#39;</span><span class="p">)</span>
    <span class="n">x</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">x0</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">n</span><span class="p">):</span>
        <span class="n">x</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">function</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">r</span><span class="p">))</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">([</span><span class="n">r</span><span class="p">]</span><span class="o">*</span><span class="n">nplot</span><span class="p">,</span> <span class="n">x</span><span class="p">[</span><span class="n">ntransient</span><span class="o">+</span><span class="mi">1</span><span class="p">:</span><span class="n">ntransient</span><span class="o">+</span><span class="n">nplot</span><span class="o">+</span><span class="mi">1</span><span class="p">],</span>
                    <span class="n">color</span><span class="o">=</span><span class="s">&#39;r&#39;</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mf">0.1</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s">&#39;.&#39;</span>
                    <span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">([</span><span class="n">r</span><span class="p">]</span><span class="o">*</span><span class="n">nplot</span><span class="p">,</span> <span class="n">x</span><span class="p">[</span><span class="n">ntransient</span><span class="o">+</span><span class="n">nplot</span><span class="o">+</span><span class="mi">1</span><span class="p">:</span><span class="n">n</span><span class="o">+</span><span class="mi">1</span><span class="p">],</span>
                    <span class="n">color</span><span class="o">=</span><span class="s">&#39;b&#39;</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mf">0.1</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s">&#39;.&#39;</span>
                    <span class="p">)</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>式<a href="#equation-e1">(1)</a>の時系列変化を描画するプログラム( <a class="reference download internal" href="../_downloads/6-8_example1.py"><tt class="xref download docutils literal"><span class="pre">6-8_example1.py</span></tt></a> )</li>
</ul>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python </span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>
<span class="c">#</span>
<span class="c"># 計算機実習</span>
<span class="c"># 問題6.8 他の1次元写像その1</span>
<span class="c">#</span>

<span class="kn">from</span> <span class="nn">math</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">SetParameter</span> <span class="c"># 同じディレクトリ内にSetParameter.pyを置く必要がある</span>
<span class="kn">import</span> <span class="nn">myplot_6_8_iterate</span> <span class="c"># 同じディレクトリ内にmyplot_6_8.pyを置く必要がある</span>

<span class="k">def</span> <span class="nf">func</span><span class="p">(</span><span class="n">x_i</span><span class="p">,</span> <span class="n">r</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">x_i</span><span class="o">*</span><span class="n">exp</span><span class="p">(</span><span class="n">r</span><span class="o">*</span><span class="p">(</span><span class="mi">1</span><span class="o">-</span><span class="n">x_i</span><span class="p">))</span>

<span class="k">def</span> <span class="nf">assignment</span><span class="p">():</span>
    <span class="n">x0</span>   <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">r</span>    <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">nmax</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
<span class="c">#    run.quit()</span>
    <span class="n">myplot_6_8_iterate</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">r</span><span class="p">,</span> <span class="n">nmax</span><span class="p">)</span>

<span class="n">parameters</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;x0&#39;</span><span class="p">:</span><span class="mf">0.4</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;r&#39;</span><span class="p">:</span><span class="mf">2.0</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;nmax&#39;</span><span class="p">:</span><span class="mi">50</span><span class="p">}]</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">run</span><span class="o">=</span><span class="n">SetParameter</span><span class="o">.</span><span class="n">SetParameter</span><span class="p">()</span>
    <span class="n">run</span><span class="o">.</span><span class="n">show_setting_window</span><span class="p">(</span><span class="n">parameters</span><span class="p">,{</span><span class="s">&#39;OK&#39;</span><span class="p">:</span><span class="n">assignment</span><span class="p">})</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>式<a href="#equation-e1">(1)</a>のBifurcation Diagramを描画するプログラム( <a class="reference download internal" href="../_downloads/6-8_example1_bifurcation.py"><tt class="xref download docutils literal"><span class="pre">6-8_example1_bifurcation.py</span></tt></a> )</li>
</ul>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python </span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>
<span class="c">#</span>
<span class="c"># 計算機実習</span>
<span class="c"># 問題6.8その1</span>

<span class="kn">from</span> <span class="nn">math</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">SetParameter</span> <span class="c"># 同じディレクトリ内にSetParameter.pyを置く必要がある</span>
<span class="kn">import</span> <span class="nn">myplot_6_8_bifurcation</span> <span class="c"># 同じディレクトリ内にmyplot_6_8_bifurcation.pyを置く必要がある</span>

<span class="k">def</span> <span class="nf">assignment</span><span class="p">():</span>
    <span class="k">def</span> <span class="nf">func</span><span class="p">(</span><span class="n">x_i</span><span class="p">,</span> <span class="n">r</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">x_i</span><span class="o">*</span><span class="n">exp</span><span class="p">(</span><span class="n">r</span><span class="o">*</span><span class="p">(</span><span class="mi">1</span><span class="o">-</span><span class="n">x_i</span><span class="p">))</span>
    <span class="n">x0</span>         <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">ntransient</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">nplot</span>      <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">r0</span>         <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">rmax</span>       <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">dr</span>         <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">5</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">run</span><span class="o">.</span><span class="n">quit</span><span class="p">()</span>
    <span class="n">myplot_6_8_bifurcation</span><span class="o">.</span><span class="n">Plot</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">ntransient</span><span class="p">,</span> <span class="n">nplot</span><span class="p">,</span> <span class="n">r0</span><span class="p">,</span> <span class="n">rmax</span><span class="p">,</span> <span class="n">dr</span><span class="p">)</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">run</span> <span class="o">=</span> <span class="n">SetParameter</span><span class="o">.</span><span class="n">SetParameter</span><span class="p">()</span>
    <span class="n">parameters</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;x0&#39;</span><span class="p">:</span><span class="mf">0.5</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;ntransient&#39;</span><span class="p">:</span><span class="mi">1000</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;nplot&#39;</span><span class="p">:</span><span class="mi">50</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;r0&#39;</span><span class="p">:</span><span class="mf">1.5</span><span class="p">},</span>
                  <span class="p">{</span><span class="s">&#39;rmax&#39;</span><span class="p">:</span><span class="mf">4.0</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;dr&#39;</span><span class="p">:</span><span class="mf">0.001</span><span class="p">}]</span>
    <span class="n">run</span><span class="o">.</span><span class="n">show_setting_window</span><span class="p">(</span><span class="n">parameters</span><span class="p">,</span> <span class="p">{</span><span class="s">&#39;OK&#39;</span><span class="p">:</span><span class="n">assignment</span><span class="p">})</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>式<a href="#equation-e2">(2)</a>の時系列変化を描画するプログラム( <a class="reference download internal" href="../_downloads/6-8_example2.py"><tt class="xref download docutils literal"><span class="pre">6-8_example2.py</span></tt></a> )</li>
</ul>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python </span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>
<span class="c">#</span>
<span class="c"># 計算機実習</span>
<span class="c"># 問題6.8 他の1次元写像その2</span>
<span class="c">#</span>

<span class="kn">from</span> <span class="nn">math</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">SetParameter</span> <span class="c"># 同じディレクトリ内にSetParameter.pyを置く必要がある</span>
<span class="kn">import</span> <span class="nn">myplot_6_8_iterate</span> <span class="c"># 同じディレクトリ内にmyplot_6_8_iterate.pyを置く必要がある</span>

<span class="k">def</span> <span class="nf">func</span><span class="p">(</span><span class="n">x_i</span><span class="p">,</span> <span class="n">r</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">r</span><span class="o">*</span><span class="n">sin</span><span class="p">(</span><span class="n">pi</span><span class="o">*</span><span class="n">x_i</span><span class="p">)</span>

<span class="k">def</span> <span class="nf">assignment</span><span class="p">():</span>
    <span class="n">x0</span>   <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">r</span>    <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">nmax</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
<span class="c">#    run.quit()</span>
    <span class="n">myplot_6_8_iterate</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">r</span><span class="p">,</span> <span class="n">nmax</span><span class="p">)</span>

<span class="n">parameters</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;x0&#39;</span><span class="p">:</span><span class="mf">0.4</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;r&#39;</span><span class="p">:</span><span class="mf">0.8</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;nmax&#39;</span><span class="p">:</span><span class="mi">50</span><span class="p">}]</span>
	
<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">run</span><span class="o">=</span><span class="n">SetParameter</span><span class="o">.</span><span class="n">SetParameter</span><span class="p">()</span>
    <span class="n">run</span><span class="o">.</span><span class="n">show_setting_window</span><span class="p">(</span><span class="n">parameters</span><span class="p">,{</span><span class="s">&#39;OK&#39;</span><span class="p">:</span><span class="n">assignment</span><span class="p">})</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>式<a href="#equation-e2">(2)</a>のBifurcation Diagramを描画するプログラム( <a class="reference download internal" href="../_downloads/6-8_example2_bifurcation.py"><tt class="xref download docutils literal"><span class="pre">6-8_example2_bifurcation.py</span></tt></a> )</li>
</ul>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python </span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>
<span class="c">#</span>
<span class="c"># 計算機実習</span>
<span class="c"># 問題6.8 他の1次元写像その2</span>

<span class="kn">from</span> <span class="nn">math</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">SetParameter</span> <span class="c"># 同じディレクトリ内にSetParameter.pyを置く必要がある</span>
<span class="kn">import</span> <span class="nn">myplot_6_8_bifurcation</span> <span class="c"># 同じディレクトリ内にmyplot_6_8_bifurcation.pyを置く必要がある</span>

<span class="k">def</span> <span class="nf">assignment</span><span class="p">():</span>
    <span class="k">def</span> <span class="nf">func</span><span class="p">(</span><span class="n">x_i</span><span class="p">,</span> <span class="n">r</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">r</span><span class="o">*</span><span class="n">sin</span><span class="p">(</span><span class="n">pi</span><span class="o">*</span><span class="n">x_i</span><span class="p">)</span>
    <span class="n">x0</span>         <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">ntransient</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">nplot</span>      <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">r0</span>         <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">rmax</span>       <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">dr</span>         <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">5</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">run</span><span class="o">.</span><span class="n">quit</span><span class="p">()</span>
    <span class="n">myplot_6_8_bifurcation</span><span class="o">.</span><span class="n">Plot</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">ntransient</span><span class="p">,</span> <span class="n">nplot</span><span class="p">,</span> <span class="n">r0</span><span class="p">,</span> <span class="n">rmax</span><span class="p">,</span> <span class="n">dr</span><span class="p">)</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">run</span><span class="o">=</span><span class="n">SetParameter</span><span class="o">.</span><span class="n">SetParameter</span><span class="p">()</span>
    <span class="n">parameters</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;x0&#39;</span><span class="p">:</span><span class="mf">0.5</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;ntransient&#39;</span><span class="p">:</span><span class="mi">1000</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;nplot&#39;</span><span class="p">:</span><span class="mi">50</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;r0&#39;</span><span class="p">:</span><span class="mf">0.</span><span class="p">},</span>
                  <span class="p">{</span><span class="s">&#39;rmax&#39;</span><span class="p">:</span><span class="mf">1.0</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;dr&#39;</span><span class="p">:</span><span class="mf">0.001</span><span class="p">}]</span>
    <span class="n">run</span><span class="o">.</span><span class="n">show_setting_window</span><span class="p">(</span><span class="n">parameters</span><span class="p">,</span> <span class="p">{</span><span class="s">&#39;OK&#39;</span><span class="p">:</span><span class="n">assignment</span><span class="p">})</span>
</pre></div>
</td></tr></table></div>
</div>
<div class="section" id="id4">
<h2><a class="toc-backref" href="#id10">実習課題</a><a class="headerlink" href="#id4" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ol class="loweralpha simple">
<li><img class="math" src="../_images/math/a0d82f91234144d78a76ecd03bc69ad8b63ba68a.png" alt="r=1.5, 2, 2.7"/>のとき、式<a href="#equation-e1">(1)</a>の時系列はどのような振る舞いを示すか。<img class="math" src="../_images/math/14546c27a7b929642f7840acca5f851c503ea109.png" alt="f(x)"/>の定性的な振る舞いについて述べよ。極大点は存在するか。(補充課題)式<a href="#equation-e2">(2)</a>の定性的な振る舞いについても調べる。</li>
</ol>
<ul class="simple">
<li>まず、2.4のプログラムを用いて、<img class="math" src="../_images/math/a0d82f91234144d78a76ecd03bc69ad8b63ba68a.png" alt="r=1.5, 2, 2.7"/>としたときの式<a href="#equation-e1">(1)</a>の時系列変化の様子を調べた。これらの実際のグラフを<a class="reference internal" href="#fig-6-8-f1"><em>図1</em></a>、<a class="reference internal" href="#fig-6-8-f2"><em>図2</em></a>、<a class="reference internal" href="#fig-6-8-f3"><em>図3</em></a>に示した。それぞれのグラフはいくつかの初期条件<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>について調べてある。これらのグラフから分かることとして、<img class="math" src="../_images/math/9f5ac4ce72fdd8e0dcd1fd1e4f900ea2c43633ef.png" alt="r=1.5"/>のときアトラクタは<img class="math" src="../_images/math/092fcccf083cc591757e2d96990c3368bf2ce486.png" alt="x=1"/>であり、<img class="math" src="../_images/math/c5c5353c9edb578cd1325c24a10765906355fd84.png" alt="x&gt;0"/>の任意の初期値に対して十分時間が経過すると周期1の運動となる。<img class="math" src="../_images/math/07484bb9532a95f15219536133950ce38f6a8c66.png" alt="r=2.0"/>の時には、系は<img class="math" src="../_images/math/092fcccf083cc591757e2d96990c3368bf2ce486.png" alt="x=1"/>に周期2で振動しながら近づいていくことがわかる。<img class="math" src="../_images/math/095b1c75cfb07f1a342ab9a1ddf8a84a16bbacd1.png" alt="r=2.7"/>の時には周期8より大きい周期で振動しており、カオス的な振る舞いを見せることが分かる。</li>
</ul>
<div class="align-center figure" id="fig-6-8-f1">
<a class="reference internal image-reference" href="../_images/figure_1-1.png"><img alt="r = 1.5 で x0 = 0.0001, 0.5, 4.0 とした時のグラフ" src="../_images/figure_1-1.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/1ee3a8485b98ffb429010d71f23221af88662210.png" alt="r = 1.5"/>で<img class="math" src="../_images/math/5f7653181047c485f2a735371733b737ae0ebae8.png" alt="x_{0} = 0.0001, 0.5, 4.0"/>とした時のグラフ</p>
</div>
<div class="align-center figure" id="fig-6-8-f2">
<a class="reference internal image-reference" href="../_images/figure_1-2.png"><img alt="r = 2.0 で x0 = 0.4, 0.7, 1.5 とした時のグラフ" src="../_images/figure_1-2.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/18dabc5df923a95bb1a3b007f816cf35f969811a.png" alt="r = 2.0"/>で<img class="math" src="../_images/math/57e5ae3ab0b1b3c0dc20aac4bb01714714266438.png" alt="x_{0} = 0.4, 0.7, 1.5"/>とした時のグラフ</p>
</div>
<div class="align-center figure" id="fig-6-8-f3">
<a class="reference internal image-reference" href="../_images/figure_1-3.png"><img alt="r=2.7 で x0 = 0.1, 2.0 とした時のグラフ" src="../_images/figure_1-3.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/095b1c75cfb07f1a342ab9a1ddf8a84a16bbacd1.png" alt="r=2.7"/>で<img class="math" src="../_images/math/853d161c6f8376cb697d856dde56ab2cb20fdb52.png" alt="x_{0} = 0.1, 2.0"/>とした時のグラフ</p>
</div>
<p>次に、適当な初期値<img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/>のもとで、十分時間が経過した後の<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>の値を<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>に関してプロットし、<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>と制御パラメータ<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>の定性的な関係について考える。<img class="math" src="../_images/math/65bdb7afd29c6245d0bf90a6468542d19a445ebc.png" alt="x_{0}=0.5"/>、<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>の刻み幅<img class="math" src="../_images/math/13091c0b55f8a6ce378ad089706493c6ac6fc742.png" alt="dr=0.001"/>として、はじめの1000回の計算結果は無視し、その後の50回を赤、さらにその後の50回を青でプロットしたものを<a class="reference internal" href="#fig-6-8-f4"><em>図4</em></a>に示す。このグラフから、先ほど考慮した時間発展についてさらに多くの示唆が与えられる。例えば<img class="math" src="../_images/math/07484bb9532a95f15219536133950ce38f6a8c66.png" alt="r=2.0"/>のとき、<a class="reference internal" href="#fig-6-8-f2"><em>図2</em></a>からだけでは、十分時間の経過した後に<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>は1に収束するのか、それとも周期2で振動するのかがわからないが、<a class="reference internal" href="#fig-6-8-f4"><em>図4</em></a>を見ると、<img class="math" src="../_images/math/07484bb9532a95f15219536133950ce38f6a8c66.png" alt="r=2.0"/>の付近で周期1から周期2への周期倍化が起こっていることが見て取れる。分岐点の位置を詳細に知るために、<img class="math" src="../_images/math/07484bb9532a95f15219536133950ce38f6a8c66.png" alt="r=2.0"/>の部分を拡大し、さらに演算回数を増やしてみると(ntransient=1000000)、ちょうど<img class="math" src="../_images/math/07484bb9532a95f15219536133950ce38f6a8c66.png" alt="r=2.0"/>で分岐することが分かる(<a class="reference internal" href="#fig-6-8-f4-2"><em>図5</em></a>)。</p>
<div class="align-center figure" id="fig-6-8-f4">
<a class="reference internal image-reference" href="../_images/figure_1-4.png"><img alt="式(1)におけるパラメータ r と x の関係" src="../_images/figure_1-4.png" style="width: 12.5cm;" /></a>
<p class="caption">式<a href="#equation-e1">(1)</a>におけるパラメータ<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>と<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>の関係</p>
</div>
<div class="align-center figure" id="fig-6-8-f4-2">
<a class="reference internal image-reference" href="../_images/figure_1-4-2.png"><img alt="r = 2.0 の近傍での x の振る舞い(dr = 0.00001)" src="../_images/figure_1-4-2.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/18dabc5df923a95bb1a3b007f816cf35f969811a.png" alt="r = 2.0"/>の近傍での<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>の振る舞い( <img class="math" src="../_images/math/d49da9ae11613870ab3996d138366c22028d46c7.png" alt="\mathrm{dr} = 0.00001"/>)</p>
</div>
<ul class="simple">
<li>式<a href="#equation-e2">(2)</a>のBifurcation-Diagramを<a class="reference internal" href="#fig-6-8-f5"><em>図6</em></a>に示す。ここで初期値<img class="math" src="../_images/math/65bdb7afd29c6245d0bf90a6468542d19a445ebc.png" alt="x_{0}=0.5"/>、プロットしない演算回数<img class="math" src="../_images/math/a9fc753b4f41e86ce85ded7db7645140d8c43836.png" alt="\mathrm{ntransient}=1000"/>、プロットする回数<img class="math" src="../_images/math/7fd56108f330ac577dcf5989c0d7f8c3ebd74c91.png" alt="\mathrm{nplot}=50"/>、<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>の刻み幅<img class="math" src="../_images/math/4426ea54a4a00a9a9b3963967be4fc0c286931ad.png" alt="\mathrm{dr}=0.001"/>とした。このグラフから、<img class="math" src="../_images/math/84efcdd11db3d97c493d74fa1f872890348d2f66.png" alt="r=0.32"/>付近で挙動が変化し(<img class="math" src="../_images/math/7a737283a623954b7a2544f44e56c4b9b20746de.png" alt="1&lt;x_{0} \le 2"/>のときはちょうど<img class="math" src="../_images/math/55ba271999995cac02cf578362df5be030594ed6.png" alt="x=0"/>で折り返した形)、<img class="math" src="../_images/math/c5a74daa6c4cc06116d678be9df6e468bf81cdb0.png" alt="r=0.71"/>で周期が2に変化している。次に<img class="math" src="../_images/math/67ebd4fb306489148231d44352029bbdbd557f00.png" alt="r=0.83"/>のあたりでさらに周期が4に変化し、<img class="math" src="../_images/math/a7419758e7c3e87fee69e11dfde1284f7091029f.png" alt="r=0.86"/>で周期8となって、その後すぐ周期16となっている。このように周期倍化の様子が観察され、以降の挙動はカオス的であることもわかる。<img class="math" src="../_images/math/55980dda6d02c1604f4aa0ffcb3b2e48c2c9c728.png" alt="r=0.94"/>付近での周期3となる窓など、いくつかの窓があることも観察される。</li>
</ul>
<div class="align-center figure" id="fig-6-8-f5">
<a class="reference internal image-reference" href="../_images/figure_2-1.png"><img alt="r に対する過渡現象以後の x の振る舞い" src="../_images/figure_2-1.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>に対する過渡現象以後の<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>の振る舞い</p>
</div>
</div>
<div class="section" id="id5">
<h2><a class="toc-backref" href="#id11">まとめ</a><a class="headerlink" href="#id5" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>1次元写像<a href="#equation-e1">(1)</a>、<a href="#equation-e2">(2)</a>の定性的な振る舞いについて調べることを通して、ロジスティック写像以外の1次元写像におけるカオス的挙動と、そこに至るまでの周期倍化などについて理解を得ることができた。分岐点の位置<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>から<img class="math" src="../_images/math/b35a9439ad8c8657b1b1d792ad5c2d77a52c0aef.png" alt="\delta"/>を算出する問題については、今後取り組むことにしたい。</p>
</div>
<div class="section" id="id6">
<h2><a class="toc-backref" href="#id12">参考文献</a><a class="headerlink" href="#id6" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li>ハーベイ・ゴールド,ジャン・トボチニク,石川正勝・宮島佐介訳『計算物理学入門』,ピアソン・エデュケーション, 2000.</li>
</ul>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">問題6.8 - 他の1次元写像</a><ul>
<li><a class="reference internal" href="#id2">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3">作成したプログラム</a></li>
<li><a class="reference internal" href="#id4">実習課題</a></li>
<li><a class="reference internal" href="#id5">まとめ</a></li>
<li><a class="reference internal" href="#id6">参考文献</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="../6-6_feigenbaum/6-6.html"
                        title="前の章へ">問題6.6 - ファイゲンバウム定数の評価</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="../6-9_lyapunov/6-9.html"
                        title="次の章へ">問題6.9 - ロジスティック写像のリアプノフ指数</a></p>
  <h3>このページ</h3>
  <ul class="this-page-menu">
    <li><a href="../_sources/6-8_other_example/6-8.txt"
           rel="nofollow">ソースコードを表示</a></li>
  </ul>
<div id="searchbox" style="display: none">
  <h3>クイック検索</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="検索" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    モジュール、クラス、または関数名を入力してください
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="../6-9_lyapunov/6-9.html" title="問題6.9 - ロジスティック写像のリアプノフ指数"
             >次へ</a> |</li>
        <li class="right" >
          <a href="../6-6_feigenbaum/6-6.html" title="問題6.6 - ファイゲンバウム定数の評価"
             >前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2014, Shotaro Fujimoto.
      このドキュメントは <a href="http://sphinx-doc.org/">Sphinx</a> 1.2.2 で生成しました。
    </div>
  </body>
</html>